import discord.ext.commands
from discord.ext import commands
from discord import Embed, Intents
from Classes import DiscordConf
from TwitterFixer import TwLink
from validators import url as is_url


# Set some validator of vx, fx pages to flag as working or not working.

class Bot(commands.Bot):
    conf: DiscordConf = None

    def __init__(self, conf: DiscordConf = None, *args, **kwargs):
        intents = Intents(messages=True, guilds=True, message_content=True)
        super(commands.Bot, self).__init__(command_prefix=conf.prefix, description=conf.description, intents=intents,
                                           self_bot=False)
        self.config = conf
        self.add_commands()

    def run(self, *args, **kwargs):
        super(commands.Bot, self).run(self.config.token, *args, **kwargs)

    async def on_ready(self):
        print('------')
        print('Logged as')
        print(self.user.name)
        print(self.user.id)
        print(
            f'invite me with: {self.invite_url}')
        print('------')

    @property
    def invite_url(self) -> str:
        return f"https://discord.com/oauth2/authorize?client_id={self.user.id}&permissions=84032&scope=bot"

    def scan_message(self, ctx: discord.Message):
        """
        Scans the message for twitter links that aren't fxtweeted.
        """

    def is_command(self, ctx: discord.Message) -> bool:
        __is_command: bool = ctx.content.startswith(self.command_prefix)
        print(f'>> `{ctx.author.name}` message is a command? {__is_command}')
        return __is_command

    async def on_message(self, ctx: discord.Message, /):

        __is_bot = ctx.author.bot

        print(f'>> `{ctx.author.name}` posted a new message, is it a bot? {__is_bot}')
        if __is_bot:
            print(f"*** ``{ctx.author.name}`` is a bot, skipping ...")
        elif self.is_command(ctx):
            await self.process_commands(ctx)
        else:

            """
            Splits message by spaces.
            
            Iterates and validates each one of the words split
            
            If the "word" is flagged as valid URL, it will proceed with the URL fixing process, which in case of being a valid URL, will post a message.            
            """
            text_split = ctx.content.split(" ")
            for word in text_split:
                if is_url(word):
                    url = word
                    tw = TwLink(url=url)
                    if tw.__bool__():
                        print(f"fixed URL from `{url}` to `{tw}`")
                        await ctx.reply(mention_author=False, content=f"Fixed Twitter Link! {tw}")

    def add_commands(self):
        @self.command()
        async def invite(ctx):
            await ctx.reply(f"You can invite me to your server with: {self.invite_url}")
